using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

namespace Forum
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			dt = new DataTable("Table");
			dt.Columns.Add("Product",typeof(System.String));
			dt.Columns.Add("Product_ID",typeof(System.Int32));
			//			dt.PrimaryKey = new DataColumn[] {dt.Columns["Product_ID"]};
			dt.Columns.Add("QtyPerUnit",typeof(System.String));
			dt.Columns.Add("UnitPrice",typeof(System.Double));

			dt.Rows.Add(new Object[] { "Cofee",1,"1 kg",Double.NaN});
			dt.Rows.Add(new Object[] { "Tea",2,"1 kg",120.00656});
			dt.Rows.Add(new Object[] { "Milk Powder",3,"1 kg",260.00565});
			dt.Rows.Add(new Object[] { "Biscuts",4,"1 Packet",20.5600});
			dt.Rows.Add(new Object[] { "Pepsi",5,"1 Lit",60.0560});
			dt.Rows.Add(new Object[] { "CoKe",6,"1 Lit",55.05650});

			dv = new DataView(dt);

			this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
			this.gridControl1.SaveCellInfo += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
			this.gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryColCount);
			this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryRowCount);
			this.gridControl1.ResetVolatileData();

			this.gridControl1.ColWidths.ResizeToFit(GridRangeInfo.Row(0));
		}
		DataView dv;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(16, 16);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(352, 272);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.DrawCellDisplayText += new Syncfusion.Windows.Forms.Grid.GridDrawCellDisplayTextEventHandler(this.gridControl1_DrawCellDisplayText);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(384, 342);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dt;

		private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				e.Style.CellValue = dv[e.RowIndex-1][e.ColIndex-1];
			}
			else if(e.ColIndex > 0 && e.RowIndex == 0)
			{
				e.Style.Text = this.dt.Columns[e.ColIndex-1].ColumnName;
			}
//			if(e.ColIndex == 4)
//				e.Style.Format = "0.###";
			e.Handled = true;

		}
		int nCols;
		int nRows;
		private DataTable GetTable()
		{
			nCols = 50;
			nRows = 200;
			DataTable dt = new DataTable("table");
			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = string.Format("row{0} col{1}", i, j);
					
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = dt.Columns.Count;
			e.Handled = true;
		}

		private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = dt.Rows.Count;
			e.Handled = true;
		}
		
		private void gridControl1_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				dv[e.RowIndex-1][e.ColIndex-1] = e.Style.CellValue.ToString();
				Console.WriteLine(dv[e.RowIndex-1][e.ColIndex-1]);
			}
			e.Handled = true;
		}

		private void gridControl1_DrawCellDisplayText(object sender, Syncfusion.Windows.Forms.Grid.GridDrawCellDisplayTextEventArgs e)
		{
			if(e.ColIndex == 4 && e.RowIndex > 0)
			{
				double d = (double)e.Style.CellValue;
					e.DisplayText = string.Format("{0:#.###}", d);
			}
		}
	}
}
